package com.mortals.xhx.busiz.uploadfile;

import com.mortals.xhx.busiz.BaseReq;
import com.mortals.xhx.module.datum.model.DatumFileEntity;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.util.List;

/**
 * 文件资料上传
 *
 * @author: zxfei
 * @date: 2021/9/6 9:26
 */
@Data
@ApiModel(value = "UploadDatumReq", description = "请求参数")
public class UploadDatumReq extends BaseReq implements Serializable {

    /**
     * 事项ID
     */
    @ApiModelProperty(value = "事项ID")
    private Long matterid;

    /**
     * siteid
     */
    @ApiModelProperty(value = "村数据下的站点id")
    private Long siteid;

    /**
     * 问答内容
     */
    @ApiModelProperty(value = "问答内容")
    private String option_content;


    /**
     * 申请人姓名
     */
    @ApiModelProperty(value = "申请人姓名")
    private String name;

    /**
     * 电话
     */
    @ApiModelProperty(value = "电话")
    private String phone;

    /**
     * 身份证
     */
    @ApiModelProperty(value = "身份证")
    private String idcard;

    /**
     * 0本人办理 1代办
     */
    @ApiModelProperty(value = "0本人办理 1代办")
    private Integer is_agent;

    /**
     * 0自主取件 1代办领取 (取件方式)
     */
    @ApiModelProperty(value = "0 自主取件 1 代办领取 (取件方式)")
    private Integer manner;

    /**
     * 村ID
     */
    @ApiModelProperty(value = "村ID")
    private Long region_id;

    /**
     * 申请材料附件列表
     *
     */
    @ApiModelProperty(value = "申请材料附件列表")
    private List<UploadFileInfo> file_arr;

}
