package com.mortals.xhx.module.datum.web;

import com.mortals.framework.exception.AppException;
import com.mortals.framework.model.Context;
import com.mortals.xhx.module.datum.model.DatumQuery;
import com.mortals.xhx.module.datum.service.DatumService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import com.mortals.framework.web.BaseCRUDJsonMappingController;
import com.mortals.xhx.module.datum.model.DatumFileEntity;
import com.mortals.xhx.module.datum.service.DatumFileService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.Map;
import java.util.stream.Collectors;


/**
* <p>Title: 申请材料附件表</p>
* <p>Description: DatumFileController  </p>
* <p>Copyright: Copyright &reg;  </p>
* <p>Company: </p>
* @author zxfei
* @version 1.0.0
*/
@RestController
@RequestMapping("datum/file")
public class DatumFileController extends BaseCRUDJsonMappingController<DatumFileService,DatumFileForm,DatumFileEntity,Long> {
    @Autowired
    private DatumService datumService;

    public DatumFileController(){
        super.setFormClass(DatumFileForm.class);
        super.setModuleDesc("申请材料附件表");
    }

    @Override
    protected void init(HttpServletRequest request, HttpServletResponse response, DatumFileForm form, Map<String, Object> model, Context context) {
        this.addDict(model, "datumid", datumService.find(new DatumQuery()).stream().collect(Collectors.toMap(x->x.getId().toString(), y->y.getMaterialName())));

    }

    @Override
    protected int doListAfter(HttpServletRequest request, HttpServletResponse response, DatumFileForm form, Map<String, Object> model, Context context) throws AppException {
        return super.doListAfter(request, response, form, model, context);
    }
}