package com.mortals.xhx.module.one.model;

import java.util.Date;
import java.math.BigDecimal;
import com.mortals.framework.model.BaseEntityLong;
/**
*
* Description:OneSite
* date: 2021-9-13 16:21:34
*/
public class OneSiteEntity extends BaseEntityLong{
    private static final long serialVersionUID = 1631521294923L;


    /**
    * 站点名称
    */
    private String siteName;

    /**
    * 是否是站点  1是 0是展示数据
    */
    private Integer isSite;

    /**
    * 标识ID
    */
    private Long iid;

    /**
    * 父级id
    */
    private Long pId;

    /**
    * 区域编号
    */
    private String regionCode;

    /**
    * 站点编号
    */
    private String siteCode;

    /**
    * 省编码
    */
    private String proCode;

    /**
    * 区编码
    */
    private String areaCode;

    /**
    * 市编码
    */
    private String cityCode;

    /**
    * 站点服务器ip
    */
    private String siteIp;

    /**
    * 站点服务器端口
    */
    private String sitePort;

    /**
    * 站点一码通mac地址
    */
    private String siteOneCodeMac;

    /**
    * 经度
    */
    private BigDecimal longitude;

    /**
    * 纬度
    */
    private BigDecimal latitude;

    /**
    * 是否有下级
    */
    private String haveSonArea;

    /**
    * 中心联系电话
    */
    private String siteTel;

    /**
    * 中心详细地址
    */
    private String detailAddress;

    /**
    * 中心介绍
    */
    private String siteRemark;

    /**
    * 上午上班开始时间
    */
    private String amWorkStartTime;

    /**
    * 上午上班结束时间
    */
    private String amWorkEndTime;

    /**
    * 下午上班开始时间
    */
    private String pmWorkStartTime;

    /**
    * 下午上班结束时间
    */
    private String pmWorkEndTime;

    /**
    * 平均等待时间,后期删除,单位毫秒
    */
    private Long averageTime;

    /**
    * 等待人数,后期删除
    */
    private Integer waitingNumber;

    /**
    * 周一 1上班 0不上
    */
    private Integer workday1;

    /**
    * 周二 1上班 0不上
    */
    private Integer workday2;

    /**
    * 周三 1上班 0不上
    */
    private Integer workday3;

    /**
    * 周四 1上班 0不上
    */
    private Integer workday4;

    /**
    * 周五 1上班 0不上
    */
    private Integer workday5;

    /**
    * 周六 1上班 0不上
    */
    private Integer workday6;

    /**
    * 周日 1上班 0不上
    */
    private Integer workday7;

    /**
    * 楼层
    */
    private Integer lv;

    /**
    * 楼栋
    */
    private Integer building;

    /**
    * 删除状态 0未删除 1已删除
    */
    private Integer deleted;

    /**
    * 创建人id
    */
    private Long createUserId;

    /**
    * 创建人名称
    */
    private String createUserName;

    /**
    * 创建时间
    */
    private Date createTime;

    /**
    * 修改人
    */
    private Long updateUserId;

    /**
    * 修改人名称
    */
    private String updateUserName;

    /**
    * 更新时间
    */
    private Date updateTime;

    public OneSiteEntity(){

    }
    /**
    * 获取 站点名称
    * @return siteName
    */
    public String getSiteName() {
        return this.siteName;
    }
    /**
    * 设置 站点名称
    * @param siteName
    */
    public void setSiteName(String siteName) {
        this.siteName = siteName;
    }
    /**
    * 获取 是否是站点  1是 0是展示数据
    * @return isSite
    */
    public Integer getIsSite() {
        return this.isSite;
    }
    /**
    * 设置 是否是站点  1是 0是展示数据
    * @param isSite
    */
    public void setIsSite(Integer isSite) {
        this.isSite = isSite;
    }
    /**
    * 获取 标识ID
    * @return iid
    */
    public Long getIid() {
        return this.iid;
    }
    /**
    * 设置 标识ID
    * @param iid
    */
    public void setIid(Long iid) {
        this.iid = iid;
    }
    /**
    * 获取 父级id
    * @return pId
    */
    public Long getPId() {
        return this.pId;
    }
    /**
    * 设置 父级id
    * @param pId
    */
    public void setPId(Long pId) {
        this.pId = pId;
    }
    /**
    * 获取 区域编号
    * @return regionCode
    */
    public String getRegionCode() {
        return this.regionCode;
    }
    /**
    * 设置 区域编号
    * @param regionCode
    */
    public void setRegionCode(String regionCode) {
        this.regionCode = regionCode;
    }
    /**
    * 获取 站点编号
    * @return siteCode
    */
    public String getSiteCode() {
        return this.siteCode;
    }
    /**
    * 设置 站点编号
    * @param siteCode
    */
    public void setSiteCode(String siteCode) {
        this.siteCode = siteCode;
    }
    /**
    * 获取 省编码
    * @return proCode
    */
    public String getProCode() {
        return this.proCode;
    }
    /**
    * 设置 省编码
    * @param proCode
    */
    public void setProCode(String proCode) {
        this.proCode = proCode;
    }
    /**
    * 获取 区编码
    * @return areaCode
    */
    public String getAreaCode() {
        return this.areaCode;
    }
    /**
    * 设置 区编码
    * @param areaCode
    */
    public void setAreaCode(String areaCode) {
        this.areaCode = areaCode;
    }
    /**
    * 获取 市编码
    * @return cityCode
    */
    public String getCityCode() {
        return this.cityCode;
    }
    /**
    * 设置 市编码
    * @param cityCode
    */
    public void setCityCode(String cityCode) {
        this.cityCode = cityCode;
    }
    /**
    * 获取 站点服务器ip
    * @return siteIp
    */
    public String getSiteIp() {
        return this.siteIp;
    }
    /**
    * 设置 站点服务器ip
    * @param siteIp
    */
    public void setSiteIp(String siteIp) {
        this.siteIp = siteIp;
    }
    /**
    * 获取 站点服务器端口
    * @return sitePort
    */
    public String getSitePort() {
        return this.sitePort;
    }
    /**
    * 设置 站点服务器端口
    * @param sitePort
    */
    public void setSitePort(String sitePort) {
        this.sitePort = sitePort;
    }
    /**
    * 获取 站点一码通mac地址
    * @return siteOneCodeMac
    */
    public String getSiteOneCodeMac() {
        return this.siteOneCodeMac;
    }
    /**
    * 设置 站点一码通mac地址
    * @param siteOneCodeMac
    */
    public void setSiteOneCodeMac(String siteOneCodeMac) {
        this.siteOneCodeMac = siteOneCodeMac;
    }
    /**
    * 获取 经度
    * @return longitude
    */
    public BigDecimal getLongitude() {
        return this.longitude;
    }
    /**
    * 设置 经度
    * @param longitude
    */
    public void setLongitude(BigDecimal longitude) {
        this.longitude = longitude;
    }
    /**
    * 获取 纬度
    * @return latitude
    */
    public BigDecimal getLatitude() {
        return this.latitude;
    }
    /**
    * 设置 纬度
    * @param latitude
    */
    public void setLatitude(BigDecimal latitude) {
        this.latitude = latitude;
    }
    /**
    * 获取 是否有下级
    * @return haveSonArea
    */
    public String getHaveSonArea() {
        return this.haveSonArea;
    }
    /**
    * 设置 是否有下级
    * @param haveSonArea
    */
    public void setHaveSonArea(String haveSonArea) {
        this.haveSonArea = haveSonArea;
    }
    /**
    * 获取 中心联系电话
    * @return siteTel
    */
    public String getSiteTel() {
        return this.siteTel;
    }
    /**
    * 设置 中心联系电话
    * @param siteTel
    */
    public void setSiteTel(String siteTel) {
        this.siteTel = siteTel;
    }
    /**
    * 获取 中心详细地址
    * @return detailAddress
    */
    public String getDetailAddress() {
        return this.detailAddress;
    }
    /**
    * 设置 中心详细地址
    * @param detailAddress
    */
    public void setDetailAddress(String detailAddress) {
        this.detailAddress = detailAddress;
    }
    /**
    * 获取 中心介绍
    * @return siteRemark
    */
    public String getSiteRemark() {
        return this.siteRemark;
    }
    /**
    * 设置 中心介绍
    * @param siteRemark
    */
    public void setSiteRemark(String siteRemark) {
        this.siteRemark = siteRemark;
    }
    /**
    * 获取 上午上班开始时间
    * @return amWorkStartTime
    */
    public String getAmWorkStartTime() {
        return this.amWorkStartTime;
    }
    /**
    * 设置 上午上班开始时间
    * @param amWorkStartTime
    */
    public void setAmWorkStartTime(String amWorkStartTime) {
        this.amWorkStartTime = amWorkStartTime;
    }
    /**
    * 获取 上午上班结束时间
    * @return amWorkEndTime
    */
    public String getAmWorkEndTime() {
        return this.amWorkEndTime;
    }
    /**
    * 设置 上午上班结束时间
    * @param amWorkEndTime
    */
    public void setAmWorkEndTime(String amWorkEndTime) {
        this.amWorkEndTime = amWorkEndTime;
    }
    /**
    * 获取 下午上班开始时间
    * @return pmWorkStartTime
    */
    public String getPmWorkStartTime() {
        return this.pmWorkStartTime;
    }
    /**
    * 设置 下午上班开始时间
    * @param pmWorkStartTime
    */
    public void setPmWorkStartTime(String pmWorkStartTime) {
        this.pmWorkStartTime = pmWorkStartTime;
    }
    /**
    * 获取 下午上班结束时间
    * @return pmWorkEndTime
    */
    public String getPmWorkEndTime() {
        return this.pmWorkEndTime;
    }
    /**
    * 设置 下午上班结束时间
    * @param pmWorkEndTime
    */
    public void setPmWorkEndTime(String pmWorkEndTime) {
        this.pmWorkEndTime = pmWorkEndTime;
    }
    /**
    * 获取 平均等待时间,后期删除,单位毫秒
    * @return averageTime
    */
    public Long getAverageTime() {
        return this.averageTime;
    }
    /**
    * 设置 平均等待时间,后期删除,单位毫秒
    * @param averageTime
    */
    public void setAverageTime(Long averageTime) {
        this.averageTime = averageTime;
    }
    /**
    * 获取 等待人数,后期删除
    * @return waitingNumber
    */
    public Integer getWaitingNumber() {
        return this.waitingNumber;
    }
    /**
    * 设置 等待人数,后期删除
    * @param waitingNumber
    */
    public void setWaitingNumber(Integer waitingNumber) {
        this.waitingNumber = waitingNumber;
    }
    /**
    * 获取 周一 1上班 0不上
    * @return workday1
    */
    public Integer getWorkday1() {
        return this.workday1;
    }
    /**
    * 设置 周一 1上班 0不上
    * @param workday1
    */
    public void setWorkday1(Integer workday1) {
        this.workday1 = workday1;
    }
    /**
    * 获取 周二 1上班 0不上
    * @return workday2
    */
    public Integer getWorkday2() {
        return this.workday2;
    }
    /**
    * 设置 周二 1上班 0不上
    * @param workday2
    */
    public void setWorkday2(Integer workday2) {
        this.workday2 = workday2;
    }
    /**
    * 获取 周三 1上班 0不上
    * @return workday3
    */
    public Integer getWorkday3() {
        return this.workday3;
    }
    /**
    * 设置 周三 1上班 0不上
    * @param workday3
    */
    public void setWorkday3(Integer workday3) {
        this.workday3 = workday3;
    }
    /**
    * 获取 周四 1上班 0不上
    * @return workday4
    */
    public Integer getWorkday4() {
        return this.workday4;
    }
    /**
    * 设置 周四 1上班 0不上
    * @param workday4
    */
    public void setWorkday4(Integer workday4) {
        this.workday4 = workday4;
    }
    /**
    * 获取 周五 1上班 0不上
    * @return workday5
    */
    public Integer getWorkday5() {
        return this.workday5;
    }
    /**
    * 设置 周五 1上班 0不上
    * @param workday5
    */
    public void setWorkday5(Integer workday5) {
        this.workday5 = workday5;
    }
    /**
    * 获取 周六 1上班 0不上
    * @return workday6
    */
    public Integer getWorkday6() {
        return this.workday6;
    }
    /**
    * 设置 周六 1上班 0不上
    * @param workday6
    */
    public void setWorkday6(Integer workday6) {
        this.workday6 = workday6;
    }
    /**
    * 获取 周日 1上班 0不上
    * @return workday7
    */
    public Integer getWorkday7() {
        return this.workday7;
    }
    /**
    * 设置 周日 1上班 0不上
    * @param workday7
    */
    public void setWorkday7(Integer workday7) {
        this.workday7 = workday7;
    }
    /**
    * 获取 楼层
    * @return lv
    */
    public Integer getLv() {
        return this.lv;
    }
    /**
    * 设置 楼层
    * @param lv
    */
    public void setLv(Integer lv) {
        this.lv = lv;
    }
    /**
    * 获取 楼栋
    * @return building
    */
    public Integer getBuilding() {
        return this.building;
    }
    /**
    * 设置 楼栋
    * @param building
    */
    public void setBuilding(Integer building) {
        this.building = building;
    }
    /**
    * 获取 删除状态 0未删除 1已删除
    * @return deleted
    */
    public Integer getDeleted() {
        return this.deleted;
    }
    /**
    * 设置 删除状态 0未删除 1已删除
    * @param deleted
    */
    public void setDeleted(Integer deleted) {
        this.deleted = deleted;
    }
    /**
    * 获取 创建人id
    * @return createUserId
    */
    public Long getCreateUserId() {
        return this.createUserId;
    }
    /**
    * 设置 创建人id
    * @param createUserId
    */
    public void setCreateUserId(Long createUserId) {
        this.createUserId = createUserId;
    }
    /**
    * 获取 创建人名称
    * @return createUserName
    */
    public String getCreateUserName() {
        return this.createUserName;
    }
    /**
    * 设置 创建人名称
    * @param createUserName
    */
    public void setCreateUserName(String createUserName) {
        this.createUserName = createUserName;
    }
    /**
    * 获取 创建时间
    * @return createTime
    */
    public Date getCreateTime() {
        return this.createTime;
    }
    /**
    * 设置 创建时间
    * @param createTime
    */
    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }
    /**
    * 获取 修改人
    * @return updateUserId
    */
    public Long getUpdateUserId() {
        return this.updateUserId;
    }
    /**
    * 设置 修改人
    * @param updateUserId
    */
    public void setUpdateUserId(Long updateUserId) {
        this.updateUserId = updateUserId;
    }
    /**
    * 获取 修改人名称
    * @return updateUserName
    */
    public String getUpdateUserName() {
        return this.updateUserName;
    }
    /**
    * 设置 修改人名称
    * @param updateUserName
    */
    public void setUpdateUserName(String updateUserName) {
        this.updateUserName = updateUserName;
    }
    /**
    * 获取 更新时间
    * @return updateTime
    */
    public Date getUpdateTime() {
        return this.updateTime;
    }
    /**
    * 设置 更新时间
    * @param updateTime
    */
    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    @Override
    public int hashCode() {
        return this.getId().hashCode();
    }
    @Override
    public boolean equals(Object obj) {
        if (obj == null)
            return false;
        if (obj instanceof OneSiteEntity) {
            OneSiteEntity tmp = (OneSiteEntity) obj;
            if (this.getId().longValue() == tmp.getId().longValue()) {
                return true;
            }
        }
        return false;
    }

    public String toString(){
        StringBuilder sb = new StringBuilder("");
        sb
        .append(",id:").append(getId())
                .append(",siteName:").append(getSiteName())
                .append(",isSite:").append(getIsSite())
                .append(",iid:").append(getIid())
                .append(",pId:").append(getPId())
                .append(",regionCode:").append(getRegionCode())
                .append(",siteCode:").append(getSiteCode())
                .append(",proCode:").append(getProCode())
                .append(",areaCode:").append(getAreaCode())
                .append(",cityCode:").append(getCityCode())
                .append(",siteIp:").append(getSiteIp())
                .append(",sitePort:").append(getSitePort())
                .append(",siteOneCodeMac:").append(getSiteOneCodeMac())
                .append(",longitude:").append(getLongitude())
                .append(",latitude:").append(getLatitude())
                .append(",haveSonArea:").append(getHaveSonArea())
                .append(",siteTel:").append(getSiteTel())
                .append(",detailAddress:").append(getDetailAddress())
                .append(",siteRemark:").append(getSiteRemark())
                .append(",amWorkStartTime:").append(getAmWorkStartTime())
                .append(",amWorkEndTime:").append(getAmWorkEndTime())
                .append(",pmWorkStartTime:").append(getPmWorkStartTime())
                .append(",pmWorkEndTime:").append(getPmWorkEndTime())
                .append(",averageTime:").append(getAverageTime())
                .append(",waitingNumber:").append(getWaitingNumber())
                .append(",workday1:").append(getWorkday1())
                .append(",workday2:").append(getWorkday2())
                .append(",workday3:").append(getWorkday3())
                .append(",workday4:").append(getWorkday4())
                .append(",workday5:").append(getWorkday5())
                .append(",workday6:").append(getWorkday6())
                .append(",workday7:").append(getWorkday7())
                .append(",lv:").append(getLv())
                .append(",building:").append(getBuilding())
                .append(",deleted:").append(getDeleted())
                .append(",createUserId:").append(getCreateUserId())
                .append(",createUserName:").append(getCreateUserName())
                .append(",createTime:").append(getCreateTime())
                .append(",updateUserId:").append(getUpdateUserId())
                .append(",updateUserName:").append(getUpdateUserName())
                .append(",updateTime:").append(getUpdateTime())
        ;
        return sb.toString();
    }

    public void initAttrValue(){
         this.siteName = null;
         this.isSite = null;
         this.iid = null;
         this.pId = null;
         this.regionCode = null;
         this.siteCode = null;
         this.proCode = null;
         this.areaCode = null;
         this.cityCode = null;
         this.siteIp = null;
         this.sitePort = null;
         this.siteOneCodeMac = null;
         this.longitude = null;
         this.latitude = null;
         this.haveSonArea = null;
         this.siteTel = null;
         this.detailAddress = null;
         this.siteRemark = null;
         this.amWorkStartTime = null;
         this.amWorkEndTime = null;
         this.pmWorkStartTime = null;
         this.pmWorkEndTime = null;
         this.averageTime = null;
         this.waitingNumber = null;
         this.workday1 = null;
         this.workday2 = null;
         this.workday3 = null;
         this.workday4 = null;
         this.workday5 = null;
         this.workday6 = null;
         this.workday7 = null;
         this.lv = null;
         this.building = null;
         this.deleted = null;
         this.createUserId = null;
         this.createUserName = null;
         this.createTime = null;
         this.updateUserId = null;
         this.updateUserName = null;
         this.updateTime = null;
    }
}