Version |  Update Time  | Status | Author |  Description
---|---|---|---|---
v2021-09-08 09:08:17|2021-09-08 09:08:17|auto|@finegirl|Created by smart-doc



## 一件事微信对外服务接口
### 一件事列表
**URL:** http://localhost:28080/zwfw/proced/thing/one_list

**Type:** POST


**Content-Type:** application/x-www-form-urlencoded;charset=utf-8

**Description:** 一件事列表

**Query-parameters:**

Parameter | Type|Description|Required|Since
---|---|---|---|---
open_id|string|微信开放id|false|-
page|int32|当前请求页数|false|-
limit|int32|每页记录数|false|-
keywords|string|搜索关键词|false|-

**Request-example:**
```
curl -X POST -i http://localhost:28080/zwfw/proced/thing/one_list --data 'limit=10&page=1&open_id=87&keywords=rvxed1'
```
**Response-fields:**

Field | Type|Description|Since
---|---|---|---
code|int32|No comments found.|-
msg|string|No comments found.|-
data|array|No comments found.|-
└─id|int64|id|-
└─tname|string|名称|-
└─matter_ids|string|事项关联id|-
└─valid|int32|是否删除（ 0正常  1删除）|-
└─create_time|int64|创建时间|-

**Response-example:**
```
{
  "code": 805,
  "msg": "f5h6lm",
  "data": [
    {
      "id": 482,
      "tname": "正豪.丁",
      "matter_ids": "v98bhx",
      "valid": 361,
      "create_time": 1631063301501
    }
  ]
}
```

### 问答数据列表
**URL:** http://localhost:28080/zwfw/proced/thing/one_problem

**Type:** POST


**Content-Type:** application/x-www-form-urlencoded;charset=utf-8

**Description:** 问答数据列表

**Query-parameters:**

Parameter | Type|Description|Required|Since
---|---|---|---|---
open_id|string|微信开放id|false|-
basics_id|int64|选中一件事ID|false|-

**Request-example:**
```
curl -X POST -i http://localhost:28080/zwfw/proced/thing/one_problem --data 'open_id=87&basics_id=675'
```
**Response-fields:**

Field | Type|Description|Since
---|---|---|---
code|int32|No comments found.|-
msg|string|No comments found.|-
data|array|No comments found.|-
└─id|int64|No comments found.|-
└─basics_id|string|No comments found.|-
└─name|string|No comments found.|-
└─type|int32|No comments found.|-
└─ismust|int32|No comments found.|-
└─level|int32|No comments found.|-
└─option_ids|string|No comments found.|-
└─create_time|int64|No comments found.|-
└─option|array|No comments found.|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─id|int64|No comments found.|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─classify_id|string|No comments found.|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─classify_next_id|string|No comments found.|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─name|string|No comments found.|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─isend|int32|No comments found.|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─basicsinfo_id|int64|No comments found.|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─accept_id|string|No comments found.|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─flowlimit_id|string|No comments found.|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─matter_id|string|No comments found.|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─datum_id|string|No comments found.|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─summary_type|int32|No comments found.|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─summary|string|No comments found.|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─create_time|int64|No comments found.|-

**Response-example:**
```
{
  "code": 188,
  "msg": "qtw83h",
  "data": [
    {
      "id": 453,
      "basics_id": "87",
      "name": "正豪.丁",
      "type": 320,
      "ismust": 817,
      "level": 922,
      "option_ids": "590o35",
      "create_time": 1631063301501,
      "option": [
        {
          "id": 655,
          "classify_id": "87",
          "classify_next_id": "87",
          "name": "正豪.丁",
          "isend": 584,
          "basicsinfo_id": 174,
          "accept_id": "87",
          "flowlimit_id": "87",
          "matter_id": "87",
          "datum_id": "87",
          "summary_type": 572,
          "summary": "9y4pe0",
          "create_time": 1631063301501
        }
      ]
    }
  ]
}
```

### 事项详细
**URL:** http://localhost:28080/zwfw/proced/thing/oneBasicsInfo

**Type:** POST


**Content-Type:** application/x-www-form-urlencoded;charset=utf-8

**Description:** 事项详细

**Query-parameters:**

Parameter | Type|Description|Required|Since
---|---|---|---|---
open_id|string|微信开放id|false|-
id|int64|一件事基础表id|false|-

**Request-example:**
```
curl -X POST -i http://localhost:28080/zwfw/proced/thing/oneBasicsInfo --data 'id=933&open_id=87'
```
**Response-fields:**

Field | Type|Description|Since
---|---|---|---
code|int32|No comments found.|-
msg|string|No comments found.|-
data|object|No comments found.|-
└─id|int64|No comments found.|-
└─datum_ids|string|材料ids|-
└─matter_ids|string|事项关联|-
└─qrcode|string|二维码（文件存储地址）|-
└─iszzsb|int32|是否自主申报 0否  1是 默认0|-
└─tname|string|'一件事标题|-
└─sort|int32|排序|-
└─valid|int32|是否删除|-
└─create_time|string|创建时间|-

**Response-example:**
```
{
  "code": 365,
  "msg": "t603mv",
  "data": {
    "id": 832,
    "datum_ids": "muu8yk",
    "matter_ids": "7mfwws",
    "qrcode": "82730",
    "iszzsb": 153,
    "tname": "正豪.丁",
    "sort": 43,
    "valid": 921,
    "create_time": "2021-09-08 09:08:21"
  }
}
```

### 问答基础信息
**URL:** http://localhost:28080/zwfw/proced/thing/condition

**Type:** POST


**Content-Type:** application/x-www-form-urlencoded;charset=utf-8

**Description:** 问答基础信息

**Query-parameters:**

Parameter | Type|Description|Required|Since
---|---|---|---|---
open_id|string|微信开放id|false|-
option_id|int64|问答最后最后选项ID|false|-
key|string|问题路线id?|false|-

**Request-example:**
```
curl -X POST -i http://localhost:28080/zwfw/proced/thing/condition --data 'key=11zjca&option_id=9&open_id=87'
```
**Response-fields:**

Field | Type|Description|Since
---|---|---|---
code|int32|No comments found.|-
msg|string|No comments found.|-
data|object|No comments found.|-
└─basicsInfo|object|No comments found.|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─id|int64|No comments found.|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─title|string|模板标题|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─basics_id|int64|一件事基础表id|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─jointInfoShow|string|办理机构|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─legalTimeLimitShow|string|法定时限|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─promiseTimeLimitShow|string|承诺时限|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─isChargesShow|int32|是否收费,0,否，1是 默认0|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─Charges|string|收费金额|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─handleTimeShow|string|办公时间|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─handlePlaceShow|string|办公地址|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─cousultingTelephoneShow|string|咨询电话|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─supervisoryTelephoneShow|string|投诉电话|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─resultInfo|string|结果信息|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─qa|string|常见问题|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─create_time|int64|No comments found.|-
└─accept|array|No comments found.|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─id|int64|No comments found.|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─title|string|模板标题|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─content|string|申请条件|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─basics_id|int64|基础表one_basics id|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─create_time|int64|创建时间|-
└─flowlimit|array|No comments found.|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─id|int64|No comments found.|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─title|string|模板标题|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─content|string|办理流程|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─basics_id|int64|基础表one_basics id|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─create_time|int64|创建时间|-
└─datum|array|No comments found.|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─id|int64|No comments found.|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─materialName|string|材料名|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─basics_id|int64|基础表one_basics id|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─matterid|int64|事项表yth_matter id 表示从一体化获取的材料|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─datum_id|int64|材料表yth_datum id 表示从一体化获取的材料|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─materialProperty|int32|材料形式|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─isMust|int32|是否必交，0 否 1 是 默认0|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─materialType|int32|材料类型|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─electronicgs|int32|电子材料格式|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─materialSource|int32|材料来源渠道|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─paperNum|int32|纸质材料份数|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─paperGg|int32|纸质材料规格|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─jianmMs|int32|减免模式|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─sealWay|int32|盖章方式|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─isjianm|int32|是否减免|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─isLack|int32|材料是否容缺|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─yb_url|string|材料地址|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─materialSourceSm|string|来源渠道说明|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─remarkSub|string|填报须知|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─remark|string|受理标准|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─clauseContent|string|要求提供材料的依据|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─summary|string|备注|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─valid|int32|0正常  1删除|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─create_time|int64|No comments found.|-

**Response-example:**
```
{
  "code": 128,
  "msg": "jzfnhp",
  "data": {
    "basicsInfo": {
      "id": 79,
      "title": "sfko0r",
      "basics_id": 992,
      "jointInfoShow": "rkc6t2",
      "legalTimeLimitShow": "34o5gf",
      "promiseTimeLimitShow": "a65igi",
      "isChargesShow": 231,
      "Charges": "8kezlr",
      "handleTimeShow": "s29f71",
      "handlePlaceShow": "czag0t",
      "cousultingTelephoneShow": "u2otba",
      "supervisoryTelephoneShow": "9sporc",
      "resultInfo": "wdlfhb",
      "qa": "6kc719",
      "create_time": 1631063301501
    },
    "accept": [
      {
        "id": 546,
        "title": "qsrmnp",
        "content": "lmvmju",
        "basics_id": 873,
        "create_time": 1631063301501
      }
    ],
    "flowlimit": [
      {
        "id": 849,
        "title": "7p32xx",
        "content": "o3x24y",
        "basics_id": 597,
        "create_time": 1631063301501
      }
    ],
    "datum": [
      {
        "id": 330,
        "materialName": "正豪.丁",
        "basics_id": 400,
        "matterid": 873,
        "datum_id": 408,
        "materialProperty": 541,
        "isMust": 254,
        "materialType": 426,
        "electronicgs": 617,
        "materialSource": 544,
        "paperNum": 659,
        "paperGg": 311,
        "jianmMs": 62,
        "sealWay": 31,
        "isjianm": 590,
        "isLack": 195,
        "yb_url": "www.xn---xn--4l5a-455q4919c.com",
        "materialSourceSm": "hwo1jl",
        "remarkSub": "e8ol9f",
        "remark": "g9mut8",
        "clauseContent": "mmnhdt",
        "summary": "ez55wv",
        "valid": 222,
        "create_time": 1631063301501
      }
    ]
  }
}
```

### 提交后请求返回数据
**URL:** http://localhost:28080/zwfw/proced/thing/datum_data

**Type:** POST


**Content-Type:** application/x-www-form-urlencoded;charset=utf-8

**Description:** 提交后请求返回数据

**Query-parameters:**

Parameter | Type|Description|Required|Since
---|---|---|---|---
key|string|No comments found.|false|-
open_id|string|No comments found.|false|-

**Request-example:**
```
curl -X POST -i http://localhost:28080/zwfw/proced/thing/datum_data --data 'key=izvap1&open_id=87'
```
**Response-fields:**

Field | Type|Description|Since
---|---|---|---
code|int32|No comments found.|-
msg|string|No comments found.|-
data|object|No comments found.|-
└─basicsInfo|object|No comments found.|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─id|int64|No comments found.|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─title|string|模板标题|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─basics_id|int64|一件事基础表id|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─jointInfoShow|string|办理机构|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─legalTimeLimitShow|string|法定时限|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─promiseTimeLimitShow|string|承诺时限|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─isChargesShow|int32|是否收费,0,否，1是 默认0|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─Charges|string|收费金额|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─handleTimeShow|string|办公时间|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─handlePlaceShow|string|办公地址|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─cousultingTelephoneShow|string|咨询电话|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─supervisoryTelephoneShow|string|投诉电话|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─resultInfo|string|结果信息|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─qa|string|常见问题|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─create_time|int64|No comments found.|-
└─accept|array|No comments found.|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─id|int64|No comments found.|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─title|string|模板标题|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─content|string|申请条件|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─basics_id|int64|基础表one_basics id|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─create_time|int64|创建时间|-
└─flowlimit|array|No comments found.|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─id|int64|No comments found.|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─title|string|模板标题|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─content|string|办理流程|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─basics_id|int64|基础表one_basics id|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─create_time|int64|创建时间|-
└─datum|array|No comments found.|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─id|int64|No comments found.|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─materialName|string|材料名|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─basics_id|int64|基础表one_basics id|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─matterid|int64|事项表yth_matter id 表示从一体化获取的材料|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─datum_id|int64|材料表yth_datum id 表示从一体化获取的材料|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─materialProperty|int32|材料形式|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─isMust|int32|是否必交，0 否 1 是 默认0|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─materialType|int32|材料类型|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─electronicgs|int32|电子材料格式|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─materialSource|int32|材料来源渠道|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─paperNum|int32|纸质材料份数|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─paperGg|int32|纸质材料规格|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─jianmMs|int32|减免模式|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─sealWay|int32|盖章方式|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─isjianm|int32|是否减免|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─isLack|int32|材料是否容缺|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─yb_url|string|材料地址|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─materialSourceSm|string|来源渠道说明|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─remarkSub|string|填报须知|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─remark|string|受理标准|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─clauseContent|string|要求提供材料的依据|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─summary|string|备注|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─valid|int32|0正常  1删除|-
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;└─create_time|int64|No comments found.|-

**Response-example:**
```
{
  "code": 963,
  "msg": "6bbvs8",
  "data": {
    "basicsInfo": {
      "id": 596,
      "title": "rtcx8t",
      "basics_id": 304,
      "jointInfoShow": "emb7gn",
      "legalTimeLimitShow": "3ofsb9",
      "promiseTimeLimitShow": "aiagro",
      "isChargesShow": 732,
      "Charges": "eym2h0",
      "handleTimeShow": "go7nc8",
      "handlePlaceShow": "7mx8ux",
      "cousultingTelephoneShow": "lgtv83",
      "supervisoryTelephoneShow": "eu9h1q",
      "resultInfo": "k5ert3",
      "qa": "8j3qga",
      "create_time": 1631063301501
    },
    "accept": [
      {
        "id": 828,
        "title": "8swwuv",
        "content": "67nvj4",
        "basics_id": 856,
        "create_time": 1631063301501
      }
    ],
    "flowlimit": [
      {
        "id": 421,
        "title": "63ovlj",
        "content": "0y0p9i",
        "basics_id": 266,
        "create_time": 1631063301501
      }
    ],
    "datum": [
      {
        "id": 115,
        "materialName": "正豪.丁",
        "basics_id": 976,
        "matterid": 772,
        "datum_id": 625,
        "materialProperty": 591,
        "isMust": 179,
        "materialType": 579,
        "electronicgs": 442,
        "materialSource": 337,
        "paperNum": 125,
        "paperGg": 169,
        "jianmMs": 356,
        "sealWay": 52,
        "isjianm": 107,
        "isLack": 164,
        "yb_url": "www.xn---xn--4l5a-455q4919c.com",
        "materialSourceSm": "i137iw",
        "remarkSub": "lzokfi",
        "remark": "zl7fqe",
        "clauseContent": "rpnusp",
        "summary": "kq5ow0",
        "valid": 311,
        "create_time": 1631063301501
      }
    ]
  }
}
```

### 上传附件
**URL:** http://localhost:28080/zwfw/proced/thing/upload_file

**Type:** POST


**Content-Type:** multipart/form-data

**Description:** 上传附件

**Query-parameters:**

Parameter | Type|Description|Required|Since
---|---|---|---|---
file|file|No comments found.|true|-

**Request-example:**
```
curl -X POST -H 'Content-Type: multipart/form-data' -i http://localhost:28080/zwfw/proced/thing/upload_file
```
**Response-fields:**

Field | Type|Description|Since
---|---|---|---
code|int32|No comments found.|-
msg|string|No comments found.|-
data|object|No comments found.|-

**Response-example:**
```
{
  "code": 323,
  "msg": "ui6kz8",
  "data": {
    "mapKey1": "r6u0ar",
    "mapKey2": "nay3dy"
  }
}
```

### 删除附件
**URL:** http://localhost:28080/zwfw/proced/thing/del_file

**Type:** POST


**Content-Type:** application/x-www-form-urlencoded;charset=utf-8

**Description:** 删除附件

**Query-parameters:**

Parameter | Type|Description|Required|Since
---|---|---|---|---
open_id|string|微信开放id|false|-
file_path|string|文件路径|false|-

**Request-example:**
```
curl -X POST -i http://localhost:28080/zwfw/proced/thing/del_file --data 'open_id=87&file_path=u0w4qs'
```
**Response-fields:**

Field | Type|Description|Since
---|---|---|---
code|int32|No comments found.|-
msg|string|No comments found.|-
data|object|No comments found.|-

**Response-example:**
```
{
  "code": 48,
  "msg": "32nwtj",
  "data": "4kfktu"
}
```

### 查询用户信息
**URL:** http://localhost:28080/zwfw/proced/thing/is_phone

**Type:** POST


**Content-Type:** application/x-www-form-urlencoded;charset=utf-8

**Description:** 查询用户信息

**Query-parameters:**

Parameter | Type|Description|Required|Since
---|---|---|---|---
open_id|string|微信开放id|false|-

**Request-example:**
```
curl -X POST -i http://localhost:28080/zwfw/proced/thing/is_phone --data 'open_id=87'
```
**Response-fields:**

Field | Type|Description|Since
---|---|---|---
code|int32|No comments found.|-
msg|string|No comments found.|-
data|object|No comments found.|-
└─id|object|No comments found.|-
└─createTime|string|创建时间|-
└─createUser|string|创建用户|-
└─createUserId|int64|No comments found.|-
└─createUserName|string|创建用户名称|-
└─createUserDeptId|int64|No comments found.|-
└─createUserDeptName|string|No comments found.|-
└─updateTime|string|No comments found.|-
└─updateUser|string|No comments found.|-
└─updateUserId|int64|No comments found.|-
└─updateUserName|string|No comments found.|-
└─updateUserDeptId|int64|No comments found.|-
└─updateUserDeptName|string|No comments found.|-
└─idcardName|string|姓名|-
└─idcardSex|string|性别|-
└─idcardNation|string|民族|-
└─idcardBorn|string|出生|-
└─idcardAddress|string|地址|-
└─idcardIDCardNo|string|身份证号|-
└─idcardGrantDept|string|发证机关|-
└─idcardUserLifeBegin|string|有效期开始|-
└─idcardUserLifeEnd|string|有效期结束|-
└─idcardDataPhotoFileName|string|照片|-
└─phone|string|手机号|-
└─unionid|string|unionid，同一个微信开放平台的唯一标识|-
└─openId|string|微信openId|-
└─picImage|string|头像地址|-
└─nickname|string|昵称|-
└─realName|string|真实姓名|-
└─gender|string|1：男，2：女|-
└─icon|string|微信头像|-
└─zImg|string|身份证正面照片|-
└─bImg|string|身份证背面照片|-
└─siteid|int64|默认选择的站点id|-
└─username|string|天府通办用户名|-
└─lasttime|string|最后登录时间|-
└─remark|string|备注|-
└─status|int32|用户状态，0:正常，1:禁用,默认0|-

**Response-example:**
```
{
  "code": 823,
  "msg": "0gwn4w",
  "data": {
    "id": "k6hp33",
    "createTime": "2021-09-08 09:08:22",
    "createUser": "3xvwt3",
    "createUserId": 302,
    "createUserName": "正豪.丁",
    "createUserDeptId": 983,
    "createUserDeptName": "正豪.丁",
    "updateTime": "2021-09-08 09:08:22",
    "updateUser": "3w97bl",
    "updateUserId": 792,
    "updateUserName": "正豪.丁",
    "updateUserDeptId": 232,
    "updateUserDeptName": "正豪.丁",
    "idcardName": "正豪.丁",
    "idcardSex": "cpzrrs",
    "idcardNation": "efcopo",
    "idcardBorn": "dvwi2e",
    "idcardAddress": "任旁96号， 宝鸡， 琼 030389",
    "idcardIDCardNo": "10b175",
    "idcardGrantDept": "vg86va",
    "idcardUserLifeBegin": "bwcxj3",
    "idcardUserLifeEnd": "zou5d5",
    "idcardDataPhotoFileName": "正豪.丁",
    "phone": "15719864910",
    "unionid": "87",
    "openId": "87",
    "picImage": "sd356b",
    "nickname": "ahmad.jenkins",
    "realName": "正豪.丁",
    "gender": "0dhmun",
    "icon": "s9n8bb",
    "zImg": "sqs5hh",
    "bImg": "ki86q4",
    "siteid": 831,
    "username": "正豪.丁",
    "lasttime": "2021-09-08 09:08:22",
    "remark": "bnu7r2",
    "status": 640
  }
}
```

### 文件资料上传
**URL:** http://localhost:28080/zwfw/proced/thing/upload_datum

**Type:** POST


**Content-Type:** application/x-www-form-urlencoded;charset=utf-8

**Description:** 文件资料上传

**Query-parameters:**

Parameter | Type|Description|Required|Since
---|---|---|---|---
open_id|string|微信开放id|false|-
matterid|int64|事项ID|false|-
siteid|int64|siteid|false|-
option_content|string|问答内容|false|-
name|string|申请人姓名|false|-
phone|string|电话|false|-
idcard|string|身份证|false|-
is_agent|int32|0本人办理 1代办|false|-
manner|int32|0自主取件 1代办领取 (取件方式)|false|-
region_id|int64|村ID|false|-
file_arr|array|申请材料附件列表|false|-
└─datumid|int64|No comments found.|false|-
└─file|string|No comments found.|false|-

**Request-example:**
```
curl -X POST -i http://localhost:28080/zwfw/proced/thing/upload_datum --data 'is_agent=928&open_id=87&file_arr[0].file=3sh8vt&manner=227&matterid=441&region_id=441&option_content=v1ia4x&phone=15719864910&name=正豪.丁&siteid=501&file_arr[0].datumid=507&idcard=231206199112313277'
```
**Response-fields:**

Field | Type|Description|Since
---|---|---|---
code|int32|No comments found.|-
msg|string|No comments found.|-
data|object|No comments found.|-

**Response-example:**
```
{
  "code": 663,
  "msg": "xqf83e",
  "data": "v19tc0"
}
```

### 我的办理
**URL:** http://localhost:28080/zwfw/proced/thing/my_handle

**Type:** POST


**Content-Type:** application/x-www-form-urlencoded;charset=utf-8

**Description:** 我的办理

**Query-parameters:**

Parameter | Type|Description|Required|Since
---|---|---|---|---
open_id|string|微信开放id|false|-

**Request-example:**
```
curl -X POST -i http://localhost:28080/zwfw/proced/thing/my_handle --data 'open_id=87'
```
**Response-fields:**

Field | Type|Description|Since
---|---|---|---
code|int32|No comments found.|-
msg|string|No comments found.|-
data|array|No comments found.|-
└─id|int64|id|-
└─matterid|string|名称|-
└─userid|int64|userid|-
└─type|int32|No comments found.|-
└─status|int32|No comments found.|-
└─summary|int32|No comments found.|-
└─address|string|No comments found.|-
└─linkman|string|No comments found.|-
└─phone|string|No comments found.|-
└─manner|int32|No comments found.|-
└─createtime|string|No comments found.|-
└─uptime|string|No comments found.|-
└─getnum|string|No comments found.|-
└─txmap|string|No comments found.|-
└─number|string|No comments found.|-
└─sign|string|No comments found.|-
└─tix|string|No comments found.|-
└─sign_file|string|No comments found.|-
└─level_status|string|No comments found.|-
└─decision_summary|string|No comments found.|-
└─option_content|string|No comments found.|-
└─uptime_descison|string|No comments found.|-
└─basics_name|string|No comments found.|-
└─create_time|int64|创建时间|-

**Response-example:**
```
{
  "code": 538,
  "msg": "3gezvt",
  "data": [
    {
      "id": 142,
      "matterid": "87",
      "userid": 550,
      "type": 82,
      "status": 303,
      "summary": 170,
      "address": "任旁96号， 宝鸡， 琼 030389",
      "linkman": "b09usw",
      "phone": "15719864910",
      "manner": 438,
      "createtime": "2021-09-08 09:08:21",
      "uptime": "2021-09-08 09:08:21",
      "getnum": "6ggw86",
      "txmap": "wd2y4p",
      "number": "d4gy2a",
      "sign": "8dkhv4",
      "tix": "s37jqj",
      "sign_file": "qe8813",
      "level_status": "2btn8l",
      "decision_summary": "igve3v",
      "option_content": "m01fto",
      "uptime_descison": "ubpeqv",
      "basics_name": "正豪.丁",
      "create_time": 1631063301501
    }
  ]
}
```

## 错误码列表
Error code |Description
---|---
200|ok
400|Bad Request
401|Unauthorized
403|Forbidden
404|Not Found
415|Unsupported Media Type
500|Internal Server Error
502|Bad Gateway
503|Service Unavailable

